--- old/usr/src/cmd/halt/halt.c	2012-07-27 03:18:26.714185290 +0400
+++ new/usr/src/cmd/halt/halt.c	2012-07-27 03:18:25.218615712 +0400
@@ -118,7 +118,7 @@
 	"svc:/system/svc/restarter:default/:properties/restarter/contract"
 
 #define	BEADM_PROG	"/usr/sbin/beadm"
-#define	BOOTADM_PROG	"/sbin/bootadm"
+#define	GRUBADM_PROG	"/sbin/grubadm"
 #define	ZONEADM_PROG	"/usr/sbin/zoneadm"
 
 /*
@@ -943,6 +943,22 @@
 	return (st);
 }
 
+static int
+exec_cmd(char * invoke, char * output)
+{
+	FILE * cmd = popen(invoke, "r");
+	if (! cmd) 
+		return 0;
+	fgets(output, 512, cmd);
+	if (! *output) {
+		pclose(cmd);
+		return 0;
+	}
+	output[strlen(output) - 2] = '\0';
+	pclose(cmd);
+	return 1;
+}
+
 /*
  * Mount the specified BE.
  *
@@ -1058,8 +1074,8 @@
 			rc = errno;
 		}
 
-		if (rc == 0 && (rc = grub_get_boot_args(&fbarg, NULL,
-		    entnum)) == 0) {
+		if (rc == 0 && (rc = exec_cmd("/sbin/grubadm --number -1 --get-opts",
+				fbarg.gba_bootargs)) == 0) {
 			if (strlcpy(bootargs_buf, fbarg.gba_bootargs,
 			    buf_size) >= buf_size) {
 				grub_cleanup_boot_args(&fbarg);
@@ -1510,8 +1526,8 @@
 	/* set new default entry in the GRUB entry */
 	if (fbarg_entnum != GRUB_ENTRY_DEFAULT) {
 		char buf[32];
-		(void) snprintf(buf, sizeof (buf), "default=%u", fbarg_entnum);
-		(void) halt_exec(BOOTADM_PROG, "set-menu", buf, NULL);
+		(void) snprintf(buf, sizeof (buf), "--set-default %u", fbarg_entnum);
+		(void) halt_exec(GRUBADM_PROG, " ", buf, NULL);
 	}
 #endif	/* __i386 */
 
